<template>
  <div class="Contenidos">
      <div v-for="nota in notas" :key="nota.notaId" class="card text-center mt-4" >
        <div class="card-header">
        usuario: {{ nota.notaUser }}
        </div>
        <div class="card-body">
          <h5 class="card-title">{{ nota.notaContent }}</h5>
          <button type="button" @click="handleEliminarContenido(nota.notaId)" class="btn btn-primary">Eliminar</button>
        </div>
      </div>
  </div>
</template>
<script>

export default {
  data (){
    return {
      notas: []
    }
  },
  methods: {
       escuchandoEmmitCN: function (){
          this.$root.$on('CNAgregarContenido', (nota) => {
              this.handleAgregarContenido(nota);
          })        
       },
       handleBuscarContenidos: function () {
          let notas = [];
          new Promise(() => setTimeout(()=>{
            fetch('http://virtual:4001/apis/notas/' + 'getData')
                    .then(data => data.json())
                    .then(res => {
                        res.data.map((nota) => {
                            return notas.push({
                                notaId: nota._id,
                                notaContent: nota.notaContent,
                                notaUser: nota.notaUser
                            });
                        });
                        this.notas = notas;
                    });
          }, 100));
      },
      handleEliminarContenido:  function (notaId){
        fetch('http://virtual:4001/apis/notas/' + 'deleteData', {
            method: 'delete',
            headers: {
                'Content-Type': 'application/json'
            },
            body: JSON.stringify({
                notaId: notaId
            })
        });
        this.handleBuscarContenidos();
      },
      handleAgregarContenido: function(nota) {
          fetch('http://virtual:4001/apis/notas/' + 'putData', {
              method: 'post',
              headers: {
                  'Content-Type': 'application/json'
              },
              body: JSON.stringify({
                  notaId: nota.notaId,
                  notaContent: nota.notaContent,
                  notaUser: nota.notaUser
              })
          });
          this.handleBuscarContenidos();
      }
  },
  created() {
    
    this.handleBuscarContenidos();
  },
  mounted() {
    this.escuchandoEmmitCN();
  }
}
</script>
